

#things for death system
#target random player (for death system)
execute unless entity @s[tag=fancy_tp_cr_pl] run tag @a[scores={fancy_tp_die=0,fancy_tp_timer=0..},tag=fancy_tp,limit=1,sort=random,tag=!fancy_tp_cr_pl0] add fancy_tp_cr_pl

#tp armor_stand to player with same id (for death system)
#execute as @e[type=minecraft:armor_stand,tag=fancy_tp_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}] fancy_tp_pl_id run tp @s @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}]
#execute as @e[type=minecraft:armor_stand,tag=fancy_tp_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}] fancy_tp_pl_id at @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}] if score !fail_timer other matches -1 run tp @s ^ ^ ^-1 facing entity @a[limit=1,tag=fancy_tp_cr_pl,scores={fancy_tp_die=..0}]


#remove tags (for death system)
tag @s remove fancy_tp_cr_pl


#give effects
effect give @s[scores={fancy_tp_stage=1..}] minecraft:regeneration 1 255 true
effect give @s[scores={fancy_tp_stage=1..}] minecraft:resistance 1 255 true

#secure system if in teleport for too long
execute as @s[scores={fancy_tp_stage=1..2,fancy_tp_safe=500..}] as @s at @s run function fancy_teleport:tp_error


#if sneak spectate armor_stand
execute unless entity @s[tag=fancy_tp_use11] run tag @a[limit=1,sort=random,tag=fancy_tp,scores={fancy_tp_stage=1..}] add fancy_tp_use11
execute as @e[type=armor_stand,tag=fancy_tp_watch_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use11,scores={fancy_tp_sneak=1..}] fancy_tp_pl_id run spectate @s @a[limit=1,tag=fancy_tp_use11,scores={fancy_tp_sneak=1..}]

#target random player and then teleport
execute unless entity @s[tag=fancy_tp_use00] run tag @a[tag=fancy_tp,limit=1,sort=random,scores={fancy_tp_stage=1..4}] add fancy_tp_use00
execute as @e[type=armor_stand,tag=fancy_tp_watch_stand] if score @s fancy_tp_en_id = @a[limit=1,tag=fancy_tp_use00] fancy_tp_pl_id at @s run tp @a[limit=1,tag=fancy_tp_use00] ~ ~ ~ 90 90
effect give @s[tag=fancy_tp_use00] levitation 5 0 true
tag @s remove fancy_tp_use00

#all stages
execute if entity @s[scores={fancy_tp_stage=0..}] run effect give @s invisibility 1 0 true

#stage 0, prep teleport mark current location and mark the targeted location
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=0}] run function fancy_teleport:tp_stage_0



#stage 1, teleport player upwards until it hits good y lvl
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=1}] run function fancy_teleport:tp_stage_1



#stage 2, teleport player towards targeted location
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=2}] run function fancy_teleport:tp_stage_2



#stage 3, message player info if nan just skip this stage
#target a random player if message. If no message set stage to 4
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=3}] run function fancy_teleport:tp_stage_3



#stage 4, teleport player downwards until it hits the correct y lvl
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=4}] run function fancy_teleport:tp_stage_4



#stage 5, reset everything! move_to stand, watch_stand, stage, gamemode.
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=5,fancy_tp_pause=..0}] run function fancy_teleport:tp_stage_5
execute as @a[scores={fancy_tp_pause=1..}] run scoreboard players remove @s fancy_tp_pause 1


#stage 6, load chunks
#target a random player
execute as @a[limit=1,sort=random,scores={fancy_tp_stage=6}] run function fancy_teleport:tp_stage_6
tag @s remove fancy_tp_use11

