


#particle in rare area
execute if entity @s[x=176,y=142,z=-242,dx=71,dy=50,dz=70] run particle ash ~ ~2 ~ 4 2 4 0 10 force

#get selected item slot
execute store result score @s pl_hotbar_slot run data get entity @s SelectedItemSlot
execute unless score @s pl_hotbar_slot = @s prev_hotbar_slot run function we:toggled_hotbar

#if holding machinegun
execute if score @s pl_hotbar_slot matches 1 if entity @s[tag=item_gun] if score !gun_count pl_items matches 2.. run replaceitem entity @s hotbar.1 crossbow{ChargedProjectiles:[{id:"minecraft:arrow",Count:1b},{},{}],Charged:1b,Unbreakable:1b,display:{Name:'[{"text":"Machine Gun","italic":false,"color":"gold"}]'},Enchantments:[{id:"quick_charge",lvl:5}],HideFlags:1} 1

#trigger objectives
execute if entity @s[scores={Ghost=1..}] run function we:trigger_objective
execute if entity @s[scores={Suicide=1..}] run function we:trigger_objective
execute if entity @s[scores={Next_Mission=1..}] run function we:trigger_objective
execute if entity @s[scores={Cheat_Mode=1..}] run function we:trigger_objective
execute if entity @s[scores={Fast_Travel=1..}] run function we:trigger_objective
execute if entity @s[scores={Next_Stage=1..}] run function we:trigger_objective
execute if entity @s[scores={Reset_Game=1..}] run function we:trigger_objective
execute if entity @s[scores={Previous_Mission=1..}] run function we:trigger_objective
execute if entity @s[scores={PvP_Mode=1..}] run function we:trigger_objective
execute if entity @s[scores={Credits=1..}] run function we:trigger_objective

#detect leave world
execute unless entity @s[x=-1,y=85,z=-252,dx=256,dy=200,dz=275] if score !fail_timer other matches -1 run scoreboard players set !fail_reason other 16


#detect in water
execute if entity @s[nbt={Air:-1s}] if score !fail_timer other matches ..0 if score !fail_reason other matches ..-1 run scoreboard players set !fail_reason other 14

#actionbar
execute if score !fail_timer other matches -1 run function we:actionbar

#detect dropped item
execute if entity @s[scores={drop_item=1..,drop_mission=..0}] run function we:dropped_item

#detect press f key
execute if entity @s[nbt={Inventory:[{Slot:-106b}]}] if score !fail_timer other matches -1 run function we:trigger_f

#detect eat beef
execute if entity @s[scores={eat_beef=1..}] run function we:used_food

#detect shoot bow/crossbow
execute if entity @s[scores={shoot_bow=1..}] if score !fail_timer other matches -1 run function we:used_gun
execute if entity @s[scores={shoot_crossbow=1..}] if score !fail_timer other matches -1 run function we:used_gun

#detect if should shoot fire
execute if entity @s[scores={flame_timer=1..,pl_hotbar_slot=4}] if score !fail_timer other matches -1 run function we:flamethrower

#detect throw grenade
execute if entity @s[scores={throw_snowball=1..}] if score !fail_timer other matches -1 run function we:throw_snowball

#detect if active grenade
execute as @e[type=armor_stand,tag=grand_stand] at @s run function we:active_grenade

#detect drink potion
execute if entity @s[scores={drink_potion=1..}] run function we:drink_potion

#title timer and hurt timer
execute if entity @s[scores={title_timer=1..}] run function we:title_timer
execute if entity @s[scores={hurt_timer=1..}] run function we:hurt_timer


#mission list
execute if score @s pl_hotbar_slot matches 8 if score !fail_timer other matches -1 run function we:mission_items
#execute unless score @s[tag=show_mission_items] pl_hotbar_slot matches 8 run clear @s
#execute unless score @s[tag=show_mission_items] pl_hotbar_slot matches 8 run function we:give_items

#give arrows
execute if entity @s[tag=!item_sniper,scores={pl_hotbar_slot=2}] if score !shotgun_count pl_items matches 1.. if score !fail_timer other matches -1 run replaceitem entity @s armor.head arrow 1
execute if entity @s[tag=!item_sniper,scores={pl_hotbar_slot=2}] if score !shotgun_count pl_items matches ..0 if score !fail_timer other matches -1 run replaceitem entity @s armor.head air 1

execute if entity @s[tag=item_sniper,scores={pl_hotbar_slot=2}] if score !sniper_count pl_items matches 1.. if score !fail_timer other matches -1 run replaceitem entity @s armor.head tipped_arrow{display:{Name:'{"text":"Heavy arrow"}'},HideFlags:127,CustomPotionEffects:[{Id:6b,Amplifier:20b,Duration:2000},{Id:7b,Amplifier:20b,Duration:2000}],CustomPotionColor:5505024} 1
execute if entity @s[tag=item_sniper,scores={pl_hotbar_slot=2}] if score !sniper_count pl_items matches ..0 if score !fail_timer other matches -1 run replaceitem entity @s armor.head air 1

execute if entity @s[tag=!item_gun,scores={pl_hotbar_slot=1}] if score !pistol_count pl_items matches 1.. if score !fail_timer other matches -1 run replaceitem entity @s armor.head arrow 1
execute if entity @s[tag=!item_gun,scores={pl_hotbar_slot=1}] if score !pistol_count pl_items matches ..0 if score !fail_timer other matches -1 run replaceitem entity @s armor.head air 1

execute if entity @s[tag=item_gun,scores={pl_hotbar_slot=1}] if score !gun_count pl_items matches 1.. if score !fail_timer other matches -1 run replaceitem entity @s armor.head arrow 1
execute if entity @s[tag=item_gun,scores={pl_hotbar_slot=1}] if score !gun_count pl_items matches ..0 if score !fail_timer other matches -1 run replaceitem entity @s armor.head air 1







